=== debian/changelog ===
beignet (0.2-2) unstable; urgency=low

  * Patch OpenCL C version

 -- Simon Richter <sjr@debian.org>  Fri, 05 Jul 2013 15:27:32 +0200

beignet (0.2-1) unstable; urgency=low

  * New upstream release (Closes: #712903)

 -- Simon Richter <sjr@debian.org>  Fri, 05 Jul 2013 15:01:51 +0200

beignet (0.1+git20130703+84f63e8-1) unstable; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Wed, 03 Jul 2013 09:52:32 +0200

beignet (0.1+git20130626+41005e0-1) unstable; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Wed, 26 Jun 2013 10:06:29 +0200

beignet (0.1+git20130625+97c3a9b-1) unstable; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Tue, 25 Jun 2013 13:52:00 +0200

beignet (0.1+git20130621+30586bf-1) unstable; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Fri, 21 Jun 2013 12:08:49 +0200

beignet (0.1+git20130619+42967d2-2) unstable; urgency=low

  * Drop EGL support for kFreeBSD for the time being

 -- Simon Richter <sjr@debian.org>  Thu, 20 Jun 2013 11:18:59 +0200

beignet (0.1+git20130619+42967d2-1) unstable; urgency=low

  * New upstream release
  * Build against Mesa 9
  * Enable GL sharing extension

 -- Simon Richter <sjr@debian.org>  Wed, 19 Jun 2013 20:48:03 +0200

beignet (0.1+git20130614+89b5e40-2) unstable; urgency=low

  * Add Ubuntu support
  * Upload to unstable to get an ICD capable package there

 -- Simon Richter <sjr@debian.org>  Fri, 14 Jun 2013 17:40:45 +0200

beignet (0.1+git20130614+89b5e40-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Fri, 14 Jun 2013 15:22:18 +0200

beignet (0.1+git20130521+a7ea35c-1) experimental; urgency=low

  * Rename binary package

 -- Simon Richter <sjr@debian.org>  Tue, 21 May 2013 10:48:39 +0200

beignet (0.1+git20130521+a7ea35c-1~prerename) experimental; urgency=low

  * New upstream release
  * Move libraries to /usr/lib/beignet (should not be used directly)

 -- Simon Richter <sjr@debian.org>  Tue, 21 May 2013 09:17:45 +0200

beignet (0.1+git20130514+19e9c58-1) experimental; urgency=low

  * New upstream release
  * Added a number of tentative patches

 -- Simon Richter <sjr@debian.org>  Tue, 14 May 2013 20:04:29 +0200

beignet (0.1+git20130502+63e60ed-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Mon, 06 May 2013 06:30:32 +0200

beignet (0.1+git20130426+0c8f6fe-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Fri, 26 Apr 2013 14:42:21 +0200

beignet (0.1+git20130422+003fac5-2) experimental; urgency=low

  * Add patch for select()
  * Add patch for fmin() / fmax()

 -- Simon Richter <sjr@debian.org>  Mon, 22 Apr 2013 18:26:01 +0200

beignet (0.1+git20130422+003fac5-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Mon, 22 Apr 2013 15:10:54 +0200

beignet (0.1+git20130419+9c11c18-1) experimental; urgency=low

  * Add more functionality patches
  * New upstream release

 -- Simon Richter <sjr@debian.org>  Fri, 19 Apr 2013 14:14:39 +0200

beignet (0.1+git20130418+0546d2e-2) experimental; urgency=low

  * Add functionality patches
  * Use clang 3.0 command line syntax

 -- Simon Richter <sjr@debian.org>  Fri, 19 Apr 2013 09:53:23 +0200

beignet (0.1+git20130418+0546d2e-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Thu, 18 Apr 2013 11:51:37 +0200

beignet (0.1-1) unstable; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Tue, 16 Apr 2013 17:16:18 +0200

beignet (0.0.0+git2013.04.11+e6b503e-1) unstable; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Mon, 15 Apr 2013 18:22:45 +0200

beignet (0.0.0+git2013.04.01+d1b234c-4) unstable; urgency=low

  * Build fix for kfreebsd-*

 -- Simon Richter <sjr@debian.org>  Fri, 12 Apr 2013 11:22:36 +0200

beignet (0.0.0+git2013.04.01+d1b234c-3) unstable; urgency=low

  * Adjust Build-Depends, Architecture list

 -- Simon Richter <sjr@debian.org>  Fri, 12 Apr 2013 10:32:36 +0200

beignet (0.0.0+git2013.04.01+d1b234c-2) unstable; urgency=low

  * Add patch to support size queries in device info

 -- Simon Richter <sjr@debian.org>  Thu, 11 Apr 2013 14:00:59 +0200

beignet (0.0.0+git2013.04.01+d1b234c-1) unstable; urgency=low

  * Initial release.

 -- Simon Richter <sjr@debian.org>  Tue, 09 Apr 2013 17:14:00 +0200
