=== debian/control ===
Source: beignet
Priority: extra
Maintainer: Simon Richter <sjr@debian.org>
Build-Depends: debhelper (>= 9), cmake, pkg-config,
 ocl-icd-dev, ocl-icd-opencl-dev,
 libdrm-dev, libxfixes-dev, libxext-dev,
 llvm-dev (>= 1:3.2),
 libclang-dev (>= 1:3.2) | libclang-dev (>= 3.2),
 libclang-dev (>= 1:3.2) | libclang-dev (<< 1:0),
 libgl1-mesa-dev (>= 9) [!kfreebsd-any],
 libegl1-mesa-dev (>= 9) [!kfreebsd-any],
 libgbm-dev (>= 9) [!kfreebsd-any]
Standards-Version: 3.9.4
Section: libs
Homepage: http://cgit.freedesktop.org/beignet/

Package: beignet-dev
Section: libdevel
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64
Depends: beignet (= ${binary:Version}), ${misc:Depends}
Description: Intel OpenCL library
 OpenCL (Open Computing Language) is a multivendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the development files for directly linking against
 the Intel implementation.

Package: beignet
Section: libs
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: beignet0.0.1
Replaces: beignet0.0.1
Provides: opencl-icd
Description: Intel OpenCL library
 OpenCL (Open Computing Language) is a multivendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the shared library for the Intel implementation.
