## beignet 0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,10 @@
 
 CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0)
 PROJECT(OCL)
-set (LIBCL_VERSION_MAJOR 0)
-set (LIBCL_VERSION_MINOR 2)
+set (LIBCL_DRIVER_VERSION_MAJOR 0)
+set (LIBCL_DRIVER_VERSION_MINOR 3)
+set (LIBCL_C_VERSION_MAJOR 1)
+set (LIBCL_C_VERSION_MINOR 1)
 
 configure_file (
   "src/OCLConfig.h.in"
@@ -48,6 +50,9 @@
   SET (USE_FULSIM "false")
   ADD_DEFINITIONS(-DEMULATE_GEN=0)
 ENDIF (EMULATE_HSW)
+
+# XXX now hard coded to enable the clamp to border workaround for IVB.
+ADD_DEFINITIONS(-DGEN7_SAMPLER_CLAMP_BORDER_WORKAROUND)
 
 IF (USE_FULSIM)
   ADD_DEFINITIONS(-DUSE_FULSIM=1)
@@ -114,21 +119,18 @@
   MESSAGE(STATUS "Looking for Gen-Backend - not found")
 ENDIF(GBE_FOUND)
 
-Find_Package(GBM)
-IF(GBM_FOUND)
-  MESSAGE(STATUS "Looking for GBM - found")
-  SET(CMAKE_CXX_FLAGS "-DHAS_GBM ${CMAKE_CXX_FLAGS}")
-  SET(CMAKE_C_FLAGS "-DHAS_GBM ${CMAKE_C_FLAGS}")
-ELSE(GBM_FOUND)
-  MESSAGE(STATUS "Looking for GBM - not found")
-ENDIF(GBM_FOUND)
-
 Find_Package(EGL)
 IF(EGL_FOUND)
   MESSAGE(STATUS "Looking for EGL - found")
 ELSE(EGL_FOUND)
   MESSAGE(STATUS "Looking for EGL - not found")
 ENDIF(EGL_FOUND)
+
+IF(MESA_SOURCE_FOUND)
+  MESSAGE(STATUS "Looking for mesa source code - found")
+ELSE(MESA_SOURCE_FOUND)
+  MESSAGE(STATUS "Looking for mesa source code - not found, cl_khr_gl_sharing will be disabled.")
+ENDIF(MESA_SOURCE_FOUND)
 
 Find_Package(OCLIcd)
 IF(OCLIcd_FOUND)
@@ -137,6 +139,8 @@
   MESSAGE(STATUS "Looking for OCL ICD header file - not found")
 ENDIF(OCLIcd_FOUND)
 
+Find_Package(PythonInterp)
+
 ADD_SUBDIRECTORY(include)
 ADD_SUBDIRECTORY(backend)
 ADD_SUBDIRECTORY(src)
