=== backend/CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,6 @@
 project (GBE)
 set (LIBGBE_VERSION_MAJOR 0)
-set (LIBGBE_VERSION_MINOR 1)
-
-configure_file (
-  "src/GBEConfig.h.in"
-  "src/GBEConfig.h"
-)
-
+set (LIBGBE_VERSION_MINOR 2)
 cmake_minimum_required (VERSION 2.6.0)
 
 set (GBE_CMAKE_DIR "${GBE_SOURCE_DIR}/cmake")
@@ -40,7 +34,7 @@
 endif (GBE_DEBUG_MEMORY)
 
 # Hide all symbols and allows the symbols declared as visible to be exported
-set (CMAKE_C_CXX_FLAGS "-fvisibility=hidden")
+set (CMAKE_C_CXX_FLAGS "-fvisibility=hidden ${CMAKE_C_CXX_FLAGS}")
 
 if (COMPILER STREQUAL "GCC")
   set (CMAKE_C_CXX_FLAGS "${CMAKE_C_CXX_FLAGS} -funroll-loops -Wstrict-aliasing=2 -fstrict-aliasing -msse2 -msse3 -mssse3 -msse4.1 -fPIC -Wall")
@@ -97,7 +91,7 @@
   set (CCMAKE_CXX_FLAGS_MINSIZEREL "-Os -DGBE_DEBUG=0")
   set (CMAKE_EXE_LINKER_FLAGS "")
 endif ()
-
+include_directories (${CMAKE_CURRENT_BINARY_DIR})
 ##############################################################
 # Project source code
 ##############################################################
