=== utests/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,7 @@
   compiler_copy_image.cpp
   compiler_copy_image_3d.cpp
   compiler_copy_buffer_row.cpp
+  compiler_degrees.cpp
   compiler_step.cpp
   compiler_fabs.cpp
   compiler_abs.cpp
@@ -40,6 +41,7 @@
   compiler_fill_image_3d_2.cpp
   compiler_function_argument0.cpp
   compiler_function_argument1.cpp
+  compiler_function_argument2.cpp
   compiler_function_argument.cpp
   compiler_function_constant0.cpp
   compiler_function_constant1.cpp
@@ -51,24 +53,30 @@
   compiler_if_else.cpp
   compiler_integer_division.cpp
   compiler_integer_remainder.cpp
+	compiler_insert_vector.cpp
   compiler_lower_return0.cpp
   compiler_lower_return1.cpp
   compiler_lower_return2.cpp
   compiler_mad_hi.cpp
   compiler_mul_hi.cpp
+  compiler_mad24.cpp
+  compiler_mul24.cpp
   compiler_multiple_kernels.cpp
+  compiler_radians.cpp
   compiler_rhadd.cpp
   compiler_rotate.cpp
   compiler_saturate.cpp
   compiler_saturate_sub.cpp
   compiler_shift_right.cpp
   compiler_short_scatter.cpp
+  compiler_smoothstep.cpp
   compiler_uint2_copy.cpp
   compiler_uint3_copy.cpp
   compiler_uint8_copy.cpp
   compiler_uint16_copy.cpp
   compiler_uint3_unaligned_copy.cpp
   compiler_upsample_int.cpp
+  compiler_upsample_long.cpp
   compiler_unstructured_branch0.cpp
   compiler_unstructured_branch1.cpp
   compiler_unstructured_branch2.cpp
@@ -79,39 +87,87 @@
   compiler_switch.cpp
   compiler_math.cpp
   compiler_atomic_functions.cpp
+  compiler_async_copy.cpp
+  compiler_async_stride_copy.cpp
   compiler_insn_selection_min.cpp
   compiler_insn_selection_max.cpp
   compiler_insn_selection_masked_min_max.cpp
+  compiler_load_bool_imm.cpp
   compiler_global_memory_barrier.cpp
   compiler_local_memory_two_ptr.cpp
   compiler_local_memory_barrier.cpp
   compiler_local_memory_barrier_wg64.cpp
   compiler_local_memory_barrier_2.cpp
+  compiler_local_slm.cpp
   compiler_movforphi_undef.cpp
   compiler_volatile.cpp
   compiler_copy_image1.cpp
   compiler_get_image_info.cpp
   compiler_vect_compare.cpp
   compiler_vector_load_store.cpp
+  compiler_vector_inc.cpp
   compiler_cl_finish.cpp
   get_cl_info.cpp
+  builtin_atan2.cpp
+  builtin_bitselect.cpp
+  builtin_frexp.cpp
+  builtin_mad_sat.cpp
+  builtin_modf.cpp
+  builtin_nextafter.cpp
+  builtin_remquo.cpp
+  builtin_shuffle.cpp
+  builtin_shuffle2.cpp
+  builtin_sign.cpp
+  builtin_sinpi.cpp
+  builtin_lgamma.cpp
+  builtin_lgamma_r.cpp
+  builtin_tgamma.cpp
   buildin_work_dim.cpp
   builtin_global_size.cpp
+  builtin_local_size.cpp
+  builtin_global_id.cpp
+  builtin_num_groups.cpp
+  builtin_local_id.cpp
+  builtin_acos_asin.cpp
+  builtin_convert_sat.cpp
   runtime_createcontext.cpp
   runtime_null_kernel_arg.cpp
+  runtime_event.cpp
   compiler_double.cpp
   compiler_double_2.cpp
   compiler_double_3.cpp
+  compiler_double_4.cpp
+  compiler_long.cpp
+  compiler_long_2.cpp
+  compiler_long_convert.cpp
+  compiler_long_shl.cpp
+  compiler_long_shr.cpp
+  compiler_long_asr.cpp
+  compiler_long_mult.cpp
+  compiler_long_cmp.cpp
+  compiler_bool_cross_basic_block.cpp
+  load_program_from_bin.cpp
+  enqueue_copy_buf.cpp
   utest_assert.cpp
   utest.cpp
   utest_file_map.cpp
   utest_helper.cpp)
 
-if (EGL_FOUND)
+SET (kernel_bin ${CMAKE_CURRENT_SOURCE_DIR}/../kernels/compiler_ceil)
+ADD_CUSTOM_COMMAND(
+    OUTPUT ${kernel_bin}.bin
+    COMMAND ${CMAKE_CURRENT_BINARY_DIR}/../backend/src/gbe_bin_generater ${kernel_bin}.cl -o${kernel_bin}.bin
+    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/../backend/src/gbe_bin_generater ${kernel_bin}.cl
+    )
+
+ADD_CUSTOM_TARGET(kernel_bin.bin
+    DEPENDS ${kernel_bin}.bin)
+
+if (EGL_FOUND AND MESA_SOURCE_FOUND)
 SET(utests_sources ${utests_sources} compiler_fill_gl_image.cpp)
 SET(CMAKE_CXX_FLAGS "-DHAS_EGL ${CMAKE_CXX_FLAGS}")
 SET(CMAKE_C_FLAGS "-DHAS_EGL ${CMAKE_C_FLAGS}")
-endif (EGL_FOUND)
+endif (EGL_FOUND AND MESA_SOURCE_FOUND)
 
 ADD_LIBRARY(utests SHARED ${utests_sources})
 
@@ -119,7 +175,7 @@
 
 ADD_EXECUTABLE(utest_run utest_run.cpp)
 TARGET_LINK_LIBRARIES(utest_run utests)
+ADD_DEPENDENCIES (utest_run kernel_bin.bin)
 
 ADD_EXECUTABLE(flat_address_space runtime_flat_address_space.cpp)
 TARGET_LINK_LIBRARIES(flat_address_space utests)
-
