=== debian/changelog ===
beignet (0.3-1) unstable; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Wed, 23 Oct 2013 21:33:44 +0200

beignet (0.2+git20130928+187c17e-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Sat, 28 Sep 2013 14:19:29 +1000

beignet (0.2+git20130816+cc09b26-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Fri, 16 Aug 2013 12:07:35 +0200

beignet (0.2+git20130807+c4d1f40-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Wed, 07 Aug 2013 16:14:06 +0200

beignet (0.2+git20130730+da26376-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Tue, 30 Jul 2013 13:43:36 +0200

beignet (0.2+git20130710+613e829-1) experimental; urgency=low

  * New upstream release

 -- Simon Richter <sjr@debian.org>  Wed, 10 Jul 2013 15:25:14 +0200
