=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: beignet
 Priority: extra
 Maintainer: Simon Richter <sjr@debian.org>
-Build-Depends: debhelper (>= 9), cmake, pkg-config,
+Build-Depends: debhelper (>= 9), cmake, pkg-config, python-minimal,
  ocl-icd-dev, ocl-icd-opencl-dev,
  libdrm-dev, libxfixes-dev, libxext-dev,
  llvm-dev (>= 1:3.2),
+ clang (>= 1:3.2) | clang (>= 3.2),
+ clang (>= 1:3.2) | clang (<< 1:0),
  libclang-dev (>= 1:3.2) | libclang-dev (>= 3.2),
  libclang-dev (>= 1:3.2) | libclang-dev (<< 1:0),
  libgl1-mesa-dev (>= 9) [!kfreebsd-any],
